/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Pseudo-instruction MC lowering Source Fragment                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

bool RISCVAsmPrinter::
lowerPseudoInstExpansion(const MachineInstr *MI, MCInst &Inst) {
  Inst.clear();
  switch (MI->getOpcode()) {
  default: return false;
  case RISCV::PseudoBR: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JAL);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: imm20
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::PseudoBRIND: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JALR);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    lowerOperand(MI->getOperand(1), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::PseudoBRINDNonX7: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JALR);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    lowerOperand(MI->getOperand(1), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::PseudoBRINDX7: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JALR);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    lowerOperand(MI->getOperand(1), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::PseudoCALLIndirect: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JALR);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X1));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(0));
    break;
  }
  case RISCV::PseudoCALLIndirectNonX7: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JALR);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X1));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(0));
    break;
  }
  case RISCV::PseudoCALLIndirectX7: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JALR);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X1));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(0));
    break;
  }
  case RISCV::PseudoRET: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JALR);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: rs1
    Inst.addOperand(MCOperand::createReg(RISCV::X1));
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(0));
    break;
  }
  case RISCV::PseudoReadVL: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::CSRRS);
    // Operand: rd
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(3104));
    // Operand: rs1
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    break;
  }
  case RISCV::PseudoReadVLENB: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::CSRRS);
    // Operand: rd
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(3106));
    // Operand: rs1
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    break;
  }
  case RISCV::PseudoTAILIndirect: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JALR);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(0));
    break;
  }
  case RISCV::PseudoTAILIndirectNonX7: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JALR);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(0));
    break;
  }
  case RISCV::PseudoTAILIndirectX7: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::JALR);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(0));
    break;
  }
  case RISCV::PseudoVSETIVLI: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::VSETIVLI);
    // Operand: rd
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: uimm
    lowerOperand(MI->getOperand(1), MCOp);
    Inst.addOperand(MCOp);
    // Operand: vtypei
    lowerOperand(MI->getOperand(2), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::PseudoVSETVLI: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::VSETVLI);
    // Operand: rd
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: rs1
    lowerOperand(MI->getOperand(1), MCOp);
    Inst.addOperand(MCOp);
    // Operand: vtypei
    lowerOperand(MI->getOperand(2), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::PseudoVSETVLIX0: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::VSETVLI);
    // Operand: rd
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: rs1
    lowerOperand(MI->getOperand(1), MCOp);
    Inst.addOperand(MCOp);
    // Operand: vtypei
    lowerOperand(MI->getOperand(2), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::ReadFFLAGS: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::CSRRS);
    // Operand: rd
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(1));
    // Operand: rs1
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    break;
  }
  case RISCV::ReadFRM: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::CSRRS);
    // Operand: rd
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(2));
    // Operand: rs1
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    break;
  }
  case RISCV::SwapFRMImm: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::CSRRWI);
    // Operand: rd
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(2));
    // Operand: rs1
    lowerOperand(MI->getOperand(1), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::WriteFFLAGS: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::CSRRW);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(1));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::WriteFRM: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::CSRRW);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(2));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::WriteFRMImm: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::CSRRWI);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(2));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  case RISCV::WriteVXRMImm: {
    MCOperand MCOp;
    Inst.setOpcode(RISCV::CSRRWI);
    // Operand: rd
    Inst.addOperand(MCOperand::createReg(RISCV::X0));
    // Operand: imm12
    Inst.addOperand(MCOperand::createImm(10));
    // Operand: rs1
    lowerOperand(MI->getOperand(0), MCOp);
    Inst.addOperand(MCOp);
    break;
  }
  }
  return true;
}

